unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite, OmegaSurface;

type
  TKostka=class(TSprite)
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Draw;override;
  end;
  TGracz=class(TSprite)
  public
    EkranX:integer;//Wspolrzedna ekranu dla kazdego z graczy
                   //y jest ta sama, X sie roni, w tym przypadku
                   //lewy ekran to X:=0; prawy to x:=400;
    x0,
    y0,            //pocztakowe ustawiena gracza we wlasnym swiecie
    xMapy,
    yMapy:single;//wzgledne wspolrzedne przesuniaca  mapy swiata dla gornego lewego rogu
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer;//indeks wycinanej klatki
                       const nazwa:string);
  end;

  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    OmegaSurface1: TOmegaSurface;
    OmegaSurface2: TOmegaSurface;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure TworzGraczy;
    procedure TworzSwiat;
    procedure UstawSwiatWedlugGracza(Gracz:TGracz);
    procedure Klawiszologia;
  public
    { Public declarations }
  end;
var
  Form1: TForm1;
  Warstwa0,
  Warstwa1:array[0..19,0..19]of TKostka;//przyjety rozmiar swiata 20x20 kostek
  GraczA,
  GraczB:TGracz;
implementation

{$R *.DFM}
//*******BLOK KOSTEK WIATA*****************************
constructor TKostka.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;
procedure TKostka.Draw;
begin
 if ImageIndex<0 then exit;
 inherited Draw;
end;
//*******KONIEC BLOKU KOSTEK WIATA*********************
//*******BLOK KLASY GRACZ*******************************
constructor TGracz.Create(const AParent: TOmegaSprite;
                          const ImageListItem: TImageListItem;
                          const IdKlatka:Integer;
                          const Nazwa:string
                       );
begin
 inherited Create(AParent);
 name:=nazwa;
 Image := ImageListItem;
 ImageIndex:=idKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
 xMapy:=0;
 yMapy:=0;
end;
//*******KONIEC BLOKU KLASY GRACZ***********************
procedure TForm1.Klawiszologia;
begin
 //Sterowanie GraczaA
 if oisButton2 in OmegaInput1.keyboard.states then//klawisz W- idz do gory
    GraczA.yMapy:=GraczA.yMapy+2;
 if oisButton4 in OmegaInput1.keyboard.states then//klawisz S- idz w d
    GraczA.yMapy:=GraczA.yMapy-2;

 if oisButton3 in OmegaInput1.keyboard.states then//klawisz D- idz w prawo
    GraczA.xMapy:=GraczA.xMapy-2;
 if oisButton5 in OmegaInput1.keyboard.states then//klawisz A- idz w lewo
    GraczA.xMapy:=GraczA.xMapy+2;

 //Sterowanie GraczaB
 if oisUp in OmegaInput1.keyboard.states then  //idz do gory
    GraczB.yMapy:=GraczB.yMapy+2;
 if oisDown in OmegaInput1.keyboard.states then  //idz w do
    GraczB.yMapy:=GraczB.yMapy-2;

 if oisRight in OmegaInput1.keyboard.states then  //idz w prawo
    GraczB.xMapy:=GraczB.xMapy-2;
 if oisLeft in OmegaInput1.keyboard.states then  //idz w lewo
    GraczB.xMapy:=GraczB.xMapy+2;
end;
procedure TForm1.UstawSwiatWedlugGracza(Gracz:TGracz);
var
 k,w:integer;
begin
 for w:=0 to high(Warstwa0)do
 for k:=0 to high(Warstwa0[0])do begin
     //wartswa gruntu
     Warstwa0[k,w].x:=Gracz.EkranX+Gracz.xMapy+k*OmegaImageList1.ImageList.Items[0].ImageWidth;
     Warstwa0[k,w].y:=             Gracz.yMapy+w*OmegaImageList1.ImageList.Items[0].ImageHeight;
     Warstwa1[k,w].x:=Warstwa0[k,w].x;
     Warstwa1[k,w].y:=Warstwa0[k,w].y;
 end;
 if Gracz.Name='GraczA'then begin
    Gracz.x:=Gracz.X0;
    Gracz.y:=Gracz.Y0;
    GraczB.X:=GraczB.X0+Gracz.xMapy-GraczB.XMapy;
    GraczB.Y:=GraczB.Y0+Gracz.yMapy-GraczB.YMapy;
 end;
 if Gracz.Name='GraczB'then begin
    Gracz.x:=Gracz.X0+Gracz.EkranX;
    Gracz.y:=Gracz.Y0;
    GraczA.X:=GraczA.X0+Gracz.EkranX+Gracz.xMapy-GraczA.XMapy;
    GraczA.Y:=GraczA.Y0+Gracz.yMapy-GraczA.YMapy;
 end;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;

 Klawiszologia;

 if not omegascreen1.CanDraw then exit;

 OmegaScreen1.BeginRender;
 OmegaScreen1.ClearScreen(0,0,0,0);

 OmegaSprite1.Dead;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs);

 //Ekran GraczA
 OmegaSurface1.BeginRender;
  OmegaScreen1.ClearScreen(0,0,0,0);
  UstawSwiatWedlugGracza(GraczA);
  OmegaSprite1.Draw;
 OmegaSurface1.EndRender;

 //Ekran GraczB
 OmegaSurface2.BeginRender;
  OmegaScreen1.ClearScreen(0,0,0,0);
  UstawSwiatWedlugGracza(GraczB);
  OmegaSprite1.Draw;
 OmegaSurface2.EndRender;

 OmegaFont1.Print(0,0, 'Adam Lasko (oksal) 14.02.2006 Zbylitowska Gra');
 OmegaFont1.Print(0,15, 'F2 zmiana trybu wywietlania aplikacji');
 OmegaFont1.Print(0,30,'FPS: '+IntToStr(OmegaTimer1.FPS));
 OmegaFont1.Print(0,45,'STEROWANIE:');
 OmegaFont1.Print(0,60,'Gracz Lewy : klawisze W, D, S, A');
 OmegaFont1.Print(0,75,'Gracz Prawy: klawisze strzaek');

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  //
  OmegaSurface1.SethWnd(self.handle);
  OmegaSurface1.Width :=400;
  OmegaSurface1.Height:=600;
  OmegaSurface1.x:=0;
  OmegaSurface1.y:=0;

  OmegaSurface2.SethWnd(self.handle);
  OmegaSurface2.Width :=400;
  OmegaSurface2.Height:=600;
  OmegaSurface2.x:=401;//przesu  o 1 piksel aby powstala linia graniczna
  OmegaSurface2.y:=0;

  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',9,[]);
  OmegaFont1.Color:=OmegaColor(255,0,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
end;
procedure TForm1.TworzGraczy;
begin
  GraczA:=TGracz.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[2],0,'GraczA');
  GraczA.X:=190;
  GraczA.Y:=300;
  GraczA.X0:=GraczA.X;
  GraczA.Y0:=GraczA.Y;
  GraczA.Z:=2;
  GraczA.EkranX:=0;

  GraczB:=TGracz.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[2],3,'GraczB');
  GraczB.X:=210;
  GraczB.Y:=300;
  GraczB.X0:=GraczB.X;
  GraczB.Y0:=GraczB.Y;
  GraczB.Z:=2;
  GraczB.EkranX:=400;
end;
procedure TForm1.TworzSwiat;
const
 element:array[0..19]of integer=
  (-1,-1,-1,-1,-1,-1,-1,-1,-1, //9/20 szans ze nic si nie wylosuje
   0,0,0,0,0,                  //5/20 szans ze wylosuj si drzewo
   1,1,1,                      //3/20 szans ze wylosuje si krzak czerowny
   3,                          //1/20 szans ze wylosuje si pomnik
   2,2                         //2/20 szans ze wylosuje si krzak niebieski
  );
var
 k,w:integer;
begin
 Randomize;
 //tworz mape swiata
 for w:=0 to high(Warstwa0)do
 for k:=0 to high(Warstwa0[0])do begin
     //wartswa gruntu
     Warstwa0[k,w]:=TKostka.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[0],0);
     Warstwa0[k,w].x:=k*OmegaImageList1.ImageList.Items[0].ImageWidth;
     Warstwa0[k,w].y:=w*OmegaImageList1.ImageList.Items[0].ImageHeight;
     Warstwa0[k,w].z:=0;
     //warstwa krzakow, drzew i innych elementow
     Warstwa1[k,w]:=TKostka.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[1],element[Random(high(element))]);
     Warstwa1[k,w].x:=k*OmegaImageList1.ImageList.Items[0].ImageWidth;
     Warstwa1[k,w].y:=w*OmegaImageList1.ImageList.Items[0].ImageHeight;
     Warstwa1[k,w].z:=1;
 end;
end;
procedure TForm1.FormShow(Sender: TObject);
begin
 TworzGraczy;
 TworzSwiat;
 OmegaTimer1.Enabled:=true;
end;

end.
